summaryrefslogtreecommitdiffstats
diff options
context:
space:
mode:
author Dave Woodfall2020-04-17 18:45:45 +0200
committer Willy Sudiarto Raharjo2020-04-19 05:52:30 +0200
commit4bd762f7d0c3a63d241d8ea80930ea7511ea2cbc (patch)
tree0dcff758abb12cd10e4209758ee2e0536ea43bb6
parentc4591233fba2ee1d13de95b4ae303212e3afa10d (diff)
downloadslackbuilds-4bd762f7d0c3a63d241d8ea80930ea7511ea2cbc.tar.gz
network/coturn: Added (open source TURN and STUN Server).
Signed-off-by: Willy Sudiarto Raharjo <willysr@slackbuilds.org>
-rw-r--r--network/coturn/README5
-rw-r--r--network/coturn/coturn.SlackBuild142
-rw-r--r--network/coturn/coturn.info10
-rw-r--r--network/coturn/doinst.sh28
-rw-r--r--network/coturn/logrotate.turnserver11
-rw-r--r--network/coturn/rc.turnserver43
-rw-r--r--network/coturn/slack-desc18
7 files changed, 257 insertions, 0 deletions
diff --git a/network/coturn/README b/network/coturn/README
new file mode 100644
index 0000000000..8f61c3a219
--- /dev/null
+++ b/network/coturn/README
@@ -0,0 +1,5 @@
+coturn (Free open source implementation of TURN and STUN Server)
+
+The TURN Server is a VoIP media traffic NAT traversal server
+and gateway. It can be used as a general-purpose network
+traffic TURN server and gateway, too.
diff --git a/network/coturn/coturn.SlackBuild b/network/coturn/coturn.SlackBuild
new file mode 100644
index 0000000000..e31ec60c54
--- /dev/null
+++ b/network/coturn/coturn.SlackBuild
@@ -0,0 +1,142 @@
+#!/bin/sh
+
+# Slackware build script for coturn
+
+# Copyright 2020 Thomas Bourdon <thomas dot bourdon at halpanet dot org>
+# All rights reserved.
+#
+# Redistribution and use of this script, with or without modification, is
+# permitted provided that the following conditions are met:
+#
+# 1. Redistributions of this script must retain the above copyright
+# notice, this list of conditions and the following disclaimer.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR ''AS IS'' AND ANY EXPRESS OR IMPLIED
+# WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
+# MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO
+# EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
+# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
+# PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
+# OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
+# WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
+# OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
+# ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+
+# Special thanks to Thomas Morper for some configuration adjustments tips
+# Modified by slackbuilds.org 2020-04-17 16:08:20 +0100
+
+PRGNAM=coturn
+VERSION=${VERSION:-4.5.1.1}
+BUILD=${BUILD:-1}
+TAG=${TAG:-_SBo}
+
+TURN_USER=${TURN_USER:-turnserver}
+TURN_GROUP=${TURN_GROUP:-turnserver}
+
+if ! grep -q ^$TURN_GROUP: /etc/group 2>/dev/null ; then
+ echo " Error: TURN group ($TURN_GROUP) doesn't exist."
+ echo " Try creating one with: groupadd -g 366 $TURN_GROUP"
+ exit 1
+fi
+
+if ! grep -q ^$TURN_USER: /etc/passwd 2>/dev/null ; then
+ echo " Error: TURN user ($TURN_USER) doesn't exist."
+ echo " Try creating one with: useradd -u 366 -g $TURN_GROUP -d /var/lib/turn -s /bin/bash $TURN_USER"
+ exit 1
+fi
+
+if [ -z "$ARCH" ]; then
+ case "$( uname -m )" in
+ i?86) ARCH=i586 ;;
+ arm*) ARCH=arm ;;
+ *) ARCH=$( uname -m ) ;;
+ esac
+fi
+
+CWD=$(pwd)
+TMP=${TMP:-/tmp/SBo}
+PKG=$TMP/package-$PRGNAM
+OUTPUT=${OUTPUT:-/tmp}
+
+if [ "$ARCH" = "i586" ]; then
+ SLKCFLAGS="-O2 -march=i586 -mtune=i686"
+ LIBDIRSUFFIX=""
+elif [ "$ARCH" = "i686" ]; then
+ SLKCFLAGS="-O2 -march=i686 -mtune=i686"
+ LIBDIRSUFFIX=""
+elif [ "$ARCH" = "x86_64" ]; then
+ SLKCFLAGS="-O2 -fPIC"
+ LIBDIRSUFFIX="64"
+else
+ SLKCFLAGS=""
+ LIBDIRSUFFIX=""
+fi
+
+set -e
+
+rm -rf $PKG
+mkdir -p $TMP $PKG $OUTPUT
+cd $TMP
+rm -rf $PRGNAM-$VERSION
+tar xvf $CWD/$PRGNAM-$VERSION.tar.?z*
+cd $PRGNAM-$VERSION
+chown -R root:root .
+find -L . \
+ \( -perm 777 -o -perm 775 -o -perm 750 -o -perm 711 -o -perm 555 \
+ -o -perm 511 \) -exec chmod 755 {} \; -o \
+ \( -perm 666 -o -perm 664 -o -perm 640 -o -perm 600 -o -perm 444 \
+ -o -perm 440 -o -perm 400 \) -exec chmod 644 {} \;
+
+CFLAGS="$SLKCFLAGS" \
+CXXFLAGS="$SLKCFLAGS" \
+./configure \
+ --prefix=/usr \
+ --libdir=/usr/lib${LIBDIRSUFFIX} \
+ --sysconfdir=/etc \
+ --localstatedir=/var \
+ --docdir=/usr/doc/$PRGNAM-$VERSION \
+ --examplesdir=/usr/share/turnserver/examples \
+ --disable-rpath \
+ --build=$ARCH-slackware-linux || exit 1
+
+make
+make install DESTDIR=$PKG
+
+sed 's%/usr/local%/usr/share/turnserver/examples%' $PKG/etc/turnserver.conf.default > $PKG/etc/turnserver.conf.new
+rm -f $PKG/etc/turnserver.conf.default
+
+mkdir -p $PKG/etc/{rc.d,logrotate.d}
+cat $CWD/rc.turnserver > $PKG/etc/rc.d/rc.turnserver.new
+cat $CWD/logrotate.turnserver > $PKG/etc/logrotate.d/turnserver.new
+
+mkdir -p $PKG/var/log/turnserver
+chown $TURN_USER:$TURN_GROUP $PKG/var/log/turnserver
+
+# Populating /etc/default/turnserver.new
+mkdir -p $PKG/etc/default
+cat << EOF > $PKG/etc/default/turnserver.new
+TURN_USER=$TURN_USER
+TURN_GROUP=$TURN_GROUP
+TURN_PID_PATH=/var/run/turnserver
+EOF
+
+rm -rf $PKG/usr/lib${LIBDIRSUFFIX}
+
+find $PKG -print0 | xargs -0 file | grep -e "executable" -e "shared object" | grep ELF \
+ | cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null || true
+
+find $PKG/usr/man -type f -exec gzip -9 {} \;
+
+mkdir -p $PKG/usr/doc/$PRGNAM-$VERSION
+cp -a AUTHORS ChangeLog LICENSE* README* \
+ $PKG/usr/doc/$PRGNAM-$VERSION
+cat $CWD/$PRGNAM.SlackBuild > $PKG/usr/doc/$PRGNAM-$VERSION/$PRGNAM.SlackBuild
+
+find $PKG/{usr/doc,usr/share,usr/include,etc,var} -type f -exec chmod -x {} +
+
+mkdir -p $PKG/install
+cat $CWD/slack-desc > $PKG/install/slack-desc
+cat $CWD/doinst.sh > $PKG/install/doinst.sh
+
+cd $PKG
+/sbin/makepkg -l y -c n $OUTPUT/$PRGNAM-$VERSION-$ARCH-$BUILD$TAG.${PKGTYPE:-tgz}
diff --git a/network/coturn/coturn.info b/network/coturn/coturn.info
new file mode 100644
index 0000000000..17cf59d3b1
--- /dev/null
+++ b/network/coturn/coturn.info
@@ -0,0 +1,10 @@
+PRGNAM="coturn"
+VERSION="4.5.1.1"
+HOMEPAGE="https://github.com/coturn/coturn"
+DOWNLOAD="https://github.com/coturn/coturn/archive/4.5.1.1/coturn-4.5.1.1.tar.gz"
+MD5SUM="ef20628b026d666be24df056f20a86ea"
+DOWNLOAD_x86_64=""
+MD5SUM_x86_64=""
+REQUIRES=""
+MAINTAINER="Thomas Bourdon"
+EMAIL="thomas dot bourdon at halpanet dot org"
diff --git a/network/coturn/doinst.sh b/network/coturn/doinst.sh
new file mode 100644
index 0000000000..e6ac736181
--- /dev/null
+++ b/network/coturn/doinst.sh
@@ -0,0 +1,28 @@
+config() {
+ NEW="$1"
+ OLD="$(dirname $NEW)/$(basename $NEW .new)"
+ # If there's no config file by that name, mv it over:
+ if [ ! -r $OLD ]; then
+ mv $NEW $OLD
+ elif [ "$(cat $OLD | md5sum)" = "$(cat $NEW | md5sum)" ]; then
+ # toss the redundant copy
+ rm $NEW
+ fi
+ # Otherwise, we leave the .new copy for the admin to consider...
+}
+
+preserve_perms() {
+ NEW="$1"
+ OLD="$(dirname ${NEW})/$(basename ${NEW} .new)"
+ if [ -e ${OLD} ]; then
+ cp -a ${OLD} ${NEW}.incoming
+ cat ${NEW} > ${NEW}.incoming
+ mv ${NEW}.incoming ${NEW}
+ fi
+ config ${NEW}
+}
+
+preserve_perms etc/rc.d/rc.turnserver.new
+config etc/turnserver.conf.new
+config etc/logrotate.d/turnserver.new
+config etc/default/turnserver.new
diff --git a/network/coturn/logrotate.turnserver b/network/coturn/logrotate.turnserver
new file mode 100644
index 0000000000..063f3c86e1
--- /dev/null
+++ b/network/coturn/logrotate.turnserver
@@ -0,0 +1,11 @@
+/var/log/turn/turn*.log {
+ su turnserver turnserver
+ daily
+ rotate 7
+ create 0644 turnserver turnserver
+ copytruncate
+ delaycompress
+ compress
+ notifempty
+ missingok
+}
diff --git a/network/coturn/rc.turnserver b/network/coturn/rc.turnserver
new file mode 100644
index 0000000000..8e34917c60
--- /dev/null
+++ b/network/coturn/rc.turnserver
@@ -0,0 +1,43 @@
+#! /bin/sh
+
+CONFIG="/etc/turnserver.conf"
+. /etc/default/turnserver
+
+coturn_start() {
+ if [ ! -d $TURN_PID_PATH ]; then
+ mkdir -p $TURN_PID_PATH
+ chown $TURN_USER:$TURN_GROUP $TURN_PID_PATH
+ fi
+ if [ -x /usr/bin/turnserver ]; then
+ echo "Starting turnserver daemon: /usr/bin/turnserver"
+ su -l -c "/usr/bin/turnserver -o -c $CONFIG --pidfile $TURN_PID_PATH/turnserver.pid" $TURN_USER
+ fi
+}
+
+coturn_stop() {
+ echo "Stopping turnserver daemon: /usr/bin/turnserver"
+ kill $(cat $TURN_PID_PATH/turnserver.pid)
+ rm -f $TURN_PID_PATH/turnserver.pid
+}
+
+coturn_restart() {
+ coturn_stop
+ sleep 1
+ coturn_start
+}
+
+case "$1" in
+'start')
+ coturn_start
+ ;;
+'stop')
+ coturn_stop
+ ;;
+'restart')
+ coturn_restart
+ ;;
+*)
+ echo "usage $0 start|stop|restart"
+esac
+
+exit 0
diff --git a/network/coturn/slack-desc b/network/coturn/slack-desc
new file mode 100644
index 0000000000..b225b7091b
--- /dev/null
+++ b/network/coturn/slack-desc
@@ -0,0 +1,18 @@
+# HOW TO EDIT THIS FILE:
+# The "handy ruler" below makes it easier to edit a package description.
+# Line up the first '|' above the ':' following the base package name, and
+# the '|' on the right side marks the last column you can put a character in.
+# You must make exactly 11 lines for the formatting to be correct. It's also
+# customary to leave one space after the ':' except on otherwise blank lines.
+
+ |-----handy-ruler------------------------------------------------------|
+coturn: coturn (Free open source implementation of TURN and STUN Server)
+coturn:
+coturn: The TURN Server is a VoIP media traffic NAT traversal server and
+coturn: gateway. It can be used as a general-purpose network traffic TURN
+coturn: server and gateway, too.
+coturn:
+coturn: Homepage: https://github.com/coturn/coturn
+coturn:
+coturn:
+coturn: